<?php
if (!defined('PHPWG_ROOT_PATH'))  die('Hacking attempt!');

function start_xml($filename, $gzip)
{
  global $file;
  $file = fopen( $filename.($gzip?'.gz':''), 'w' );
  out_xml('<?xml version="1.0" encoding="UTF-8"?>
<urlset xmlns="http://www.google.com/schemas/sitemap/0.84">', $gzip );
}

function out_xml($xml, $gzip)
{
  global $file;
  if ($gzip)
    fwrite($file, gzencode($xml, 9) );
  else
    fwrite($file, $xml);
}

function end_xml($gzip)
{
  global $file;
  out_xml('</urlset>',$gzip );
  fclose( $file );
}

function add_url($url, $lastmod=null, $changefreq=null, $priority=null)
{
  $xml=
'<url>
 <loc>'.$url.'</loc>';

  if ( isset($lastmod) and strlen($lastmod)>0 )
  {
    if (strlen($lastmod)>11)
    {
      $lastmod[10] = 'T';
      if (strlen($lastmod)==19)
      	$lastmod .= '-05:00';
    }
    $xml.='
 <lastmod>'.$lastmod.'</lastmod>';
  }

  if ( isset($changefreq) and $changefreq!='' ) $xml.='
 <changefreq>'.$changefreq.'</changefreq>';

  if ( isset($priority) and $priority!='' ) $xml.='
 <priority>'.$priority.'</priority>';

  $xml .= '
</url>';
global $gzip;
  out_xml($xml, $gzip);
}

include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
check_status(ACCESS_ADMINISTRATOR);

$frequencies = array(
    '',
    'always',
    'hourly',
    'daily',
    'weekly',
    'monthly',
    'yearly',
    'never',
  );

$specials = array(
  'categories' => array('L'=>l10n('home'), 'P'=>0.95),
  'best_rated' => array( 'L'=>l10n('best_rated_cat'), 'P'=>0.9 ) ,
  'most_visited' => array('L'=>l10n('most_visited_cat'), 'P'=>0.9 ),
  'recent_pics' => array('L'=>l10n('recent_pics_cat'), 'P'=>0.9, 'F'=>'weekly' ),
  'tags' => array('L'=>l10n('Tags'), 'PAGE'=>'tags', 'P'=>0.9 ),
  );


$query = '
SELECT id, name, uppercats, global_rank, date_last
  FROM '.CATEGORIES_TABLE.'
  WHERE status=\'public\' AND visible=\'true\'
  ORDER BY global_rank
;';
$result = pwg_query($query);
$categories = array();
while ($row = mysql_fetch_array($result))
{
  array_push($categories, $row);
}
usort($categories, 'global_rank_compare');

$query = 'SELECT id FROM '.CATEGORIES_TABLE.'
  WHERE status=\'private\'  AND visible=\'false\'
;';
$forbidden_categories = array_from_query( $query, 'id');
if (empty($forbidden_categories)) $forbidden_categories=null;
$tags = get_available_tags($forbidden_categories);


if ( isset($_POST['submit']) )
{
  // echo('<pre>'.var_export($_POST,true).'</pre>' );

  if ( $_POST['filename'] != '' )
    $filename = $_POST['filename'];
  $gzip = @$_POST['gzip']=='on' ? true : false;

  $selected_specials = array();
  foreach ($specials as $key=>$value)
  {
    if ( $_POST['special_'.$key]=='on' )
      array_push( $selected_specials, $key );
    $specials[$key]['P'] = $_POST['special_prio_'.$key];
    $specials[$key]['F'] = $_POST['special_freq_'.$key];
  }

  if ( isset($_POST['categories']) )
    $selected_categories = array_values( $_POST['categories'] );
  else
    $selected_categories = array();
  $prio_categories = $_POST['prio_categories'];
  $freq_categories = $_POST['freq_categories'];

  if ( isset($_POST['tags']) )
    $selected_tags = array_values( $_POST['tags'] );
  else
    $selected_tags = array();
  $prio_tags = $_POST['prio_tags'];
  $freq_tags = $_POST['freq_tags'];

  start_xml($filename, $gzip);

  $root_path_save = @$page['root_path'];
  $page['root_path'] = 'http://'.$_SERVER['HTTP_HOST'].cookie_path();

  $r_selected_specials = array_flip($selected_specials);
  foreach ($specials as $key=>$value)
  {
    if (! isset ($r_selected_specials[$key]) )
      continue;
    if ( isset($value['PAGE']) )
      $url = get_root_url().$value['PAGE'];
    else
      $url = make_index_url( array('section'=>$key) );
    add_url($url, null, $value['F'], $value['P'] );
  }


  $r_selected_categories = array_flip($selected_categories);
  foreach ($categories as $value)
  {
    if (! isset ($r_selected_categories[$value['id']]) )
      continue;

    $url = make_index_url(
            array(
              'category'=>$value['id'],
              'cat_name'=>$value['name'],
            )
        );
    add_url($url, $value['date_last'], $freq_categories, $prio_categories);
  }

  if ( !empty($selected_tags) )
  {
    $r_selected_tags = array_flip($selected_tags);
    $query = 'SELECT tag_id, MAX(date_available) AS da, MAX(date_creation) AS dc, MAX(date_metadata_update) AS dm
  FROM '.IMAGE_TAG_TABLE.' INNER JOIN '.IMAGES_TABLE.' ON image_id=id
  WHERE tag_id IN ('.implode(',',$selected_tags).')
  GROUP BY tag_id';
    $result = pwg_query($query);
    $tag_infos = array();
    while ($row = mysql_fetch_array($result))
    {
      $tag_infos[$row['tag_id']]= max( $row['da'],$row['dc'],$row['dm']);
    }

    foreach( $tags as $tag)
    {
      if (!in_array($tag['tag_id'], $selected_tags) )
        continue;

      $url = make_index_url(
            array(
              'section'=>'tags',
              'tags'=> array($tag),
            )
        );
      add_url($url, $tag_infos[ $tag['tag_id'] ], $freq_tags, $prio_tags);
    }
  }
  $page['root_path'] = $root_path_save;
  end_xml($gzip);
}
else
{
  $filename = 'sitemap.xml';
  $gzip = false;
  $selected_categories = array();
  $selected_specials = 'all';
  $selected_tags = 'all';
  $prio_categories = 0.6;
  $prio_tags = 0.7;
  $freq_categories = 'monthly';
  $freq_tags = 'monthly';
}


$template->set_filenames(array('sitemap' => 'admin/_sitemap.tpl'));

$template->assign_vars( array(
  'FILENAME' => $filename,
  'U_FILENAME' => get_root_url().$filename.($gzip?'.gz':''),
  'GZIP_CHECKED' => $gzip ? 'checked="checked"' : '',
  'PRIO_CATEGORIES' => $prio_categories,
  'PRIO_TAGS' => $prio_tags,
    )
  );

$template->assign_block_vars( 'specials', array() );
foreach( $specials as $key=>$value)
{
  $checked='';
  if ($selected_specials=='all' or in_array($key, $selected_specials) )
    $checked = 'checked="checked"';

  $template->assign_block_vars( 'specials.special',
    array(
      'NAME' => $key,
      'LABEL' =>  $value['L'],
      'CHECKED' => $checked,
      'PRIO' => $value['P'],
      )
    );
  foreach ($frequencies as $frequency)
  {
    $selected='';
    if ( !isset($value['F']) ? $frequency=='monthly' : $value['F']==$frequency )
      $selected = 'selected="selected"';

    $template->assign_block_vars( 'specials.special.frequency',
      array(
        'VALUE' => $frequency,
        'SELECTED' => $selected,
        )
      );
  }
}

display_select_categories($categories, $selected_categories, 'category', false );
foreach ($frequencies as $frequency)
{
  $selected='';
  if ( $freq_categories==$frequency )
    $selected = 'selected="selected"';
  $template->assign_block_vars( 'freq_categories',
    array(
      'VALUE' => $frequency,
      'SELECTED' => $selected,
      )
    );
}

foreach( $tags as $tag)
{
  $selected='';
  if ($selected_tags=='all' or in_array($tag['tag_id'], $selected_tags) )
    $selected = 'selected="selected"';
  $template->assign_block_vars( 'tag',
    array(
      'VALUE' => $tag['tag_id'],
      'OPTION' => $tag['name'],
      'SELECTED' => $selected,
      )
    );
}
foreach ($frequencies as $frequency)
{
  $selected='';
  if ( $freq_tags==$frequency )
    $selected = 'selected="selected"';
  $template->assign_block_vars( 'freq_tags',
    array(
      'VALUE' => $frequency,
      'SELECTED' => $selected,
      )
    );
}

$template->assign_var_from_handle('ADMIN_CONTENT', 'sitemap');

?>